diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/lr-wpan/model/lr-wpan-mac.cc ns-3.43/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.42/src/lr-wpan/model/lr-wpan-mac.cc	2024-05-29 15:29:46.976073300 -0700
+++ ns-3.43/src/lr-wpan/model/lr-wpan-mac.cc	2024-10-09 16:41:09.900656000 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors:
  *  Gary Pei <guangyu.pei@boeing.com>
@@ -40,7 +29,7 @@
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT                                                                      \
-    std::clog << "[address " << m_shortAddress << " | " << m_macExtendedAddress << "] ";
+    std::clog << "[" << m_shortAddress << " | " << m_macExtendedAddress << "] ";
 
 namespace ns3
 {
@@ -93,7 +82,8 @@
 LrWpanMac::GetTypeId()
 {
     static TypeId tid =
-        TypeId("ns3::LrWpanMac")
+        TypeId("ns3::lrwpan::LrWpanMac")
+            .AddDeprecatedName("ns3::LrWpanMac")
             .SetParent<LrWpanMacBase>()
             .SetGroupName("LrWpan")
             .AddConstructor<LrWpanMac>()
@@ -187,12 +177,12 @@
             .AddTraceSource("MacState",
                             "The state of LrWpan Mac",
                             MakeTraceSourceAccessor(&LrWpanMac::m_macStateLogger),
-                            "ns3::LrWpanMac::StateTracedCallback")
+                            "ns3::lrwpan::LrWpanMac::StateTracedCallback")
             .AddTraceSource("MacSentPkt",
                             "Trace source reporting some information about "
                             "the sent packet",
                             MakeTraceSourceAccessor(&LrWpanMac::m_sentPktTrace),
-                            "ns3::LrWpanMac::SentTracedCallback")
+                            "ns3::lrwpan::LrWpanMac::SentTracedCallback")
             .AddTraceSource("IfsEnd",
                             "Trace source reporting the end of an "
                             "Interframe space (IFS)",
@@ -252,12 +242,10 @@
     m_maxTxQueueSize = m_txQueue.max_size();
     m_maxIndTxQueueSize = m_indTxQueue.max_size();
 
-    Ptr<UniformRandomVariable> uniformVar = CreateObject<UniformRandomVariable>();
-    uniformVar->SetAttribute("Min", DoubleValue(0.0));
-    uniformVar->SetAttribute("Max", DoubleValue(255.0));
-    m_macDsn = SequenceNumber8(uniformVar->GetValue());
-    m_macBsn = SequenceNumber8(uniformVar->GetValue());
-    m_macBeaconPayload = nullptr;
+    m_uniformVar = CreateObject<UniformRandomVariable>();
+    m_macDsn = SequenceNumber8(m_uniformVar->GetInteger(0, 255));
+    m_macBsn = SequenceNumber8(m_uniformVar->GetInteger(0, 255));
+    m_macBeaconPayload = {};
     m_macBeaconPayloadLength = 0;
     m_shortAddress = Mac16Address("FF:FF"); // FF:FF = The address is not assigned.
 }
@@ -357,28 +345,24 @@
 void
 LrWpanMac::SetShortAddress(Mac16Address address)
 {
-    NS_LOG_FUNCTION(this << address);
     m_shortAddress = address;
 }
 
 void
 LrWpanMac::SetExtendedAddress(Mac64Address address)
 {
-    NS_LOG_FUNCTION(this << address);
     m_macExtendedAddress = address;
 }
 
 Mac16Address
 LrWpanMac::GetShortAddress() const
 {
-    NS_LOG_FUNCTION(this);
     return m_shortAddress;
 }
 
 Mac64Address
 LrWpanMac::GetExtendedAddress() const
 {
-    NS_LOG_FUNCTION(this);
     return m_macExtendedAddress;
 }
 
@@ -924,19 +908,28 @@
 
     switch (id)
     {
+    case macAssociationPermit:
+        m_macAssociationPermit = attribute->macAssociationPermit;
+        break;
     case macBeaconPayload:
-        if (attribute->macBeaconPayload->GetSize() > lrwpan::aMaxBeaconPayloadLength)
+        if (attribute->macBeaconPayload.size() > aMaxBeaconPayloadLength)
         {
             confirmParams.m_status = MacStatus::INVALID_PARAMETER;
         }
         else
         {
             m_macBeaconPayload = attribute->macBeaconPayload;
-            m_macBeaconPayloadLength = attribute->macBeaconPayload->GetSize();
         }
         break;
     case macBeaconPayloadLength:
-        confirmParams.m_status = MacStatus::INVALID_PARAMETER;
+        if (attribute->macBeaconPayloadLength > aMaxBeaconPayloadLength)
+        {
+            confirmParams.m_status = MacStatus::INVALID_PARAMETER;
+        }
+        else
+        {
+            m_macBeaconPayloadLength = attribute->macBeaconPayloadLength;
+        }
         break;
     case macShortAddress:
         m_shortAddress = attribute->macShortAddress;
@@ -947,6 +940,24 @@
     case macPanId:
         m_macPanId = macPanId;
         break;
+    case macPromiscuousMode:
+        m_macPromiscuousMode = attribute->macPromiscuousMode;
+        break;
+    case macRxOnWhenIdle:
+        m_macRxOnWhenIdle = attribute->macRxOnWhenIdle;
+        break;
+    case pCurrentChannel: {
+        Ptr<PhyPibAttributes> pibAttr = Create<PhyPibAttributes>();
+        pibAttr->phyCurrentChannel = attribute->pCurrentChannel;
+        m_phy->PlmeSetAttributeRequest(PhyPibAttributeIdentifier::phyCurrentChannel, pibAttr);
+        break;
+    }
+    case pCurrentPage: {
+        Ptr<PhyPibAttributes> pibAttr = Create<PhyPibAttributes>();
+        pibAttr->phyCurrentPage = attribute->pCurrentPage;
+        m_phy->PlmeSetAttributeRequest(PhyPibAttributeIdentifier::phyCurrentPage, pibAttr);
+        break;
+    }
     default:
         // TODO: Add support for setting other attributes
         confirmParams.m_status = MacStatus::UNSUPPORTED_ATTRIBUTE;
@@ -968,12 +979,21 @@
 
     switch (id)
     {
+    case macAssociationPermit:
+        attributes->macAssociationPermit = m_macAssociationPermit;
+        break;
     case macBeaconPayload:
         attributes->macBeaconPayload = m_macBeaconPayload;
         break;
     case macBeaconPayloadLength:
         attributes->macBeaconPayloadLength = m_macBeaconPayloadLength;
         break;
+    case macPromiscuousMode:
+        attributes->macPromiscuousMode = m_macPromiscuousMode;
+        break;
+    case macRxOnWhenIdle:
+        attributes->macRxOnWhenIdle = m_macRxOnWhenIdle;
+        break;
     case macShortAddress:
         attributes->macShortAddress = m_shortAddress;
         break;
@@ -1006,21 +1026,21 @@
     NS_LOG_FUNCTION(this);
     NS_ASSERT(m_macState == MAC_IDLE);
 
-    LrWpanMacHeader macHdr(LrWpanMacHeader::LRWPAN_MAC_BEACON, m_macBsn.GetValue());
     m_macBsn++;
-    BeaconPayloadHeader macPayload;
-    Ptr<Packet> beaconPacket;
-    LrWpanMacTrailer macTrailer;
 
-    if (m_macBeaconPayload == nullptr)
+    Ptr<Packet> beaconPacket;
+    if (m_macBeaconPayload.empty())
     {
         beaconPacket = Create<Packet>();
     }
     else
     {
-        beaconPacket = m_macBeaconPayload;
+        // Extract the octets from m_macBeaconPayload and place them in a packet
+        uint8_t* octets = &m_macBeaconPayload[0];
+        beaconPacket = Create<Packet>(octets, m_macBeaconPayload.size());
     }
 
+    LrWpanMacHeader macHdr(LrWpanMacHeader::LRWPAN_MAC_BEACON, m_macBsn.GetValue());
     macHdr.SetDstAddrMode(LrWpanMacHeader::SHORTADDR);
     macHdr.SetDstAddrFields(GetPanId(), Mac16Address("ff:ff"));
 
@@ -1039,6 +1059,7 @@
     macHdr.SetSecDisable();
     macHdr.SetNoAckReq();
 
+    BeaconPayloadHeader macPayload;
     macPayload.SetSuperframeSpecField(GetSuperframeField());
     macPayload.SetGtsFields(GetGtsFields());
     macPayload.SetPndAddrFields(GetPendingAddrFields());
@@ -1047,6 +1068,7 @@
     beaconPacket->AddHeader(macHdr);
 
     // Calculate FCS if the global attribute ChecksumEnabled is set.
+    LrWpanMacTrailer macTrailer;
     if (Node::ChecksumEnabled())
     {
         macTrailer.EnableFcs(true);
@@ -1055,18 +1077,28 @@
 
     beaconPacket->AddTrailer(macTrailer);
 
-    // Set the Beacon packet to be transmitted
-    m_txPkt = beaconPacket;
-
     if (m_csmaCa->IsSlottedCsmaCa())
     {
+        // Beacon in beacon-enabled mode
+        // Transmit beacon immediately (i.e. Without CSMA/CA)
+        m_txPkt = beaconPacket;
         m_outSuperframeStatus = BEACON;
         NS_LOG_DEBUG("Outgoing superframe Active Portion (Beacon + CAP + CFP): "
                      << m_superframeDuration << " symbols");
-    }
 
-    ChangeMacState(MAC_SENDING);
-    m_phy->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_TX_ON);
+        ChangeMacState(MAC_SENDING);
+        m_phy->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_TX_ON);
+    }
+    else
+    {
+        // Beacon as a result of a beacon request
+        // The beacon shall be transmitted using CSMA/CA
+        // IEEE 802.15.4-2011 (Section 5.1.2.1.2)
+        Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+        txQElement->txQPkt = beaconPacket;
+        EnqueueTxQElement(txQElement);
+        CheckQueue();
+    }
 }
 
 void
@@ -1714,6 +1746,210 @@
 }
 
 void
+LrWpanMac::ReceiveBeacon(uint8_t lqi, Ptr<Packet> p)
+{
+    NS_LOG_FUNCTION(this << lqi << p);
+    // The received beacon size in symbols
+    // Beacon = Sync Header (SHR)[5 bytes] +
+    //          PHY header (PHR) [1 byte]  +
+    //          PSDU (MAC header + beacon payload) [default 17 bytes]
+    m_rxBeaconSymbols = m_phy->GetPhySHRDuration() + 1 * m_phy->GetPhySymbolsPerOctet() +
+                        (p->GetSize() * m_phy->GetPhySymbolsPerOctet());
+
+    // The start of Rx beacon time and start of the Incoming superframe Active Period
+    auto symbolRate = (uint64_t)m_phy->GetDataOrSymbolRate(false); // symbols per second
+    m_macBeaconRxTime = Simulator::Now() - Seconds(double(m_rxBeaconSymbols) / symbolRate);
+
+    NS_LOG_DEBUG("Beacon Received; forwarding up (m_macBeaconRxTime: "
+                 << m_macBeaconRxTime.As(Time::S) << ")");
+
+    // Strip the MAC header, the trailer and the Beacon Payload
+    LrWpanMacTrailer receivedMacTrailer;
+    p->RemoveTrailer(receivedMacTrailer);
+
+    LrWpanMacHeader receivedMacHdr;
+    p->RemoveHeader(receivedMacHdr);
+
+    BeaconPayloadHeader receivedMacPayload;
+    p->RemoveHeader(receivedMacPayload);
+
+    // Fill the PAN descriptor
+    PanDescriptor panDescriptor;
+
+    if (receivedMacHdr.GetSrcAddrMode() == SHORT_ADDR)
+    {
+        panDescriptor.m_coorAddrMode = SHORT_ADDR;
+        panDescriptor.m_coorShortAddr = receivedMacHdr.GetShortSrcAddr();
+    }
+    else
+    {
+        panDescriptor.m_coorAddrMode = EXT_ADDR;
+        panDescriptor.m_coorExtAddr = receivedMacHdr.GetExtSrcAddr();
+    }
+
+    panDescriptor.m_coorPanId = receivedMacHdr.GetSrcPanId();
+    panDescriptor.m_gtsPermit = receivedMacPayload.GetGtsFields().GetGtsPermit();
+    panDescriptor.m_linkQuality = lqi;
+    panDescriptor.m_logChPage = m_phy->GetCurrentPage();
+    panDescriptor.m_logCh = m_phy->GetCurrentChannelNum();
+    panDescriptor.m_superframeSpec = receivedMacPayload.GetSuperframeSpecField();
+    panDescriptor.m_timeStamp = m_macBeaconRxTime;
+
+    // Process beacon when device belongs to a PAN (associated device)
+    if (!m_scanEvent.IsPending() && m_macPanId == receivedMacHdr.GetDstPanId())
+    {
+        // We need to make sure to cancel any possible ongoing unslotted CSMA/CA
+        // operations when receiving a beacon (e.g. Those taking place at the
+        // beginning of an Association).
+        m_csmaCa->Cancel();
+
+        SuperframeField incomingSuperframe(receivedMacPayload.GetSuperframeSpecField());
+
+        m_incomingBeaconOrder = incomingSuperframe.GetBeaconOrder();
+        m_incomingSuperframeOrder = incomingSuperframe.GetFrameOrder();
+        m_incomingFnlCapSlot = incomingSuperframe.GetFinalCapSlot();
+
+        if (m_incomingBeaconOrder < 15)
+        {
+            // Start Beacon-enabled mode
+            m_csmaCa->SetSlottedCsmaCa();
+            m_incomingBeaconInterval = (static_cast<uint32_t>(1 << m_incomingBeaconOrder)) *
+                                       lrwpan::aBaseSuperframeDuration;
+            m_incomingSuperframeDuration = lrwpan::aBaseSuperframeDuration *
+                                           (static_cast<uint32_t>(1 << m_incomingSuperframeOrder));
+
+            if (incomingSuperframe.IsBattLifeExt())
+            {
+                m_csmaCa->SetBatteryLifeExtension(true);
+            }
+            else
+            {
+                m_csmaCa->SetBatteryLifeExtension(false);
+            }
+
+            // TODO: get Incoming frame GTS Fields here
+
+            // Begin CAP on the current device using info from
+            // the Incoming superframe
+            NS_LOG_DEBUG("Incoming superframe Active Portion "
+                         << "(Beacon + CAP + CFP): " << m_incomingSuperframeDuration << " symbols");
+
+            m_incCapEvent =
+                Simulator::ScheduleNow(&LrWpanMac::StartCAP, this, SuperframeType::INCOMING);
+        }
+        else
+        {
+            // Start non-beacon enabled mode
+            m_csmaCa->SetUnSlottedCsmaCa();
+        }
+
+        m_setMacState = Simulator::ScheduleNow(&LrWpanMac::SetLrWpanMacState, this, MAC_IDLE);
+    }
+    else if (!m_scanEvent.IsPending() && m_macPanId == 0xFFFF)
+    {
+        NS_LOG_DEBUG(this << " Device not associated, cannot process beacon");
+    }
+
+    if (m_macAutoRequest)
+    {
+        if (p->GetSize() > 0)
+        {
+            if (!m_mlmeBeaconNotifyIndicationCallback.IsNull())
+            {
+                // The beacon contains payload, send the beacon notification.
+                MlmeBeaconNotifyIndicationParams beaconParams;
+                beaconParams.m_bsn = receivedMacHdr.GetSeqNum();
+                beaconParams.m_panDescriptor = panDescriptor;
+                beaconParams.m_sduLength = p->GetSize();
+                beaconParams.m_sdu = p;
+                m_mlmeBeaconNotifyIndicationCallback(beaconParams);
+            }
+        }
+
+        if (m_scanEvent.IsPending())
+        {
+            // Channel scanning is taking place, save only unique PAN descriptors
+            bool descriptorExists = false;
+
+            for (const auto& descriptor : m_panDescriptorList)
+            {
+                if (descriptor.m_coorAddrMode == SHORT_ADDR)
+                {
+                    // Found a coordinator in PAN descriptor list with the same
+                    // registered short address
+                    descriptorExists =
+                        (descriptor.m_coorShortAddr == panDescriptor.m_coorShortAddr &&
+                         descriptor.m_coorPanId == panDescriptor.m_coorPanId);
+                }
+                else
+                {
+                    // Found a coordinator in PAN descriptor list with the same
+                    // registered extended address
+                    descriptorExists = (descriptor.m_coorExtAddr == panDescriptor.m_coorExtAddr &&
+                                        descriptor.m_coorPanId == panDescriptor.m_coorPanId);
+                }
+
+                if (descriptorExists)
+                {
+                    break;
+                }
+            }
+
+            if (!descriptorExists)
+            {
+                m_panDescriptorList.emplace_back(panDescriptor);
+            }
+            return;
+        }
+        else if (m_trackingEvent.IsPending())
+        {
+            // check if MLME-SYNC.request was previously issued and running
+            // Sync. is necessary to handle pending messages (indirect
+            // transmissions)
+            m_trackingEvent.Cancel();
+            m_numLostBeacons = 0;
+
+            if (m_beaconTrackingOn)
+            {
+                // if tracking option is on keep tracking the next beacon
+                uint64_t searchSymbols;
+                Time searchBeaconTime;
+
+                searchSymbols = (static_cast<uint64_t>(1 << m_incomingBeaconOrder)) +
+                                1 * lrwpan::aBaseSuperframeDuration;
+                searchBeaconTime = Seconds(static_cast<double>(searchSymbols / symbolRate));
+                m_trackingEvent =
+                    Simulator::Schedule(searchBeaconTime, &LrWpanMac::BeaconSearchTimeout, this);
+            }
+
+            PendingAddrFields pndAddrFields;
+            pndAddrFields = receivedMacPayload.GetPndAddrFields();
+
+            // TODO: Ignore pending data, and do not send data command request if
+            // the address is in the GTS list.
+            //       If the address is not in the GTS list, then  check if the
+            //       address is in the short address pending list or in the extended
+            //       address pending list and send a data command request.
+        }
+    }
+    else
+    {
+        // m_macAutoRequest is FALSE
+        // Data command request are not send, only the beacon notification.
+        // see IEEE 802.15.4-2011 Section 6.2.4.1
+        if (!m_mlmeBeaconNotifyIndicationCallback.IsNull())
+        {
+            MlmeBeaconNotifyIndicationParams beaconParams;
+            beaconParams.m_bsn = receivedMacHdr.GetSeqNum();
+            beaconParams.m_panDescriptor = panDescriptor;
+            beaconParams.m_sduLength = p->GetSize();
+            beaconParams.m_sdu = p;
+            m_mlmeBeaconNotifyIndicationCallback(beaconParams);
+        }
+    }
+}
+
+void
 LrWpanMac::CheckQueue()
 {
     NS_LOG_FUNCTION(this);
@@ -1875,15 +2111,29 @@
         if (m_macPromiscuousMode)
         {
             // level 2 filtering
-            if (receivedMacHdr.GetDstAddrMode() == SHORT_ADDR)
+            if (receivedMacHdr.GetSrcAddrMode() == SHORT_ADDR &&
+                receivedMacHdr.GetDstAddrMode() == SHORT_ADDR)
             {
-                NS_LOG_DEBUG("Packet from " << params.m_srcAddr);
-                NS_LOG_DEBUG("Packet to " << params.m_dstAddr);
+                NS_LOG_DEBUG("Packet from [" << params.m_srcAddr << "] to [" << params.m_dstAddr
+                                             << "]");
             }
-            else if (receivedMacHdr.GetDstAddrMode() == EXT_ADDR)
+            else if (receivedMacHdr.GetSrcAddrMode() == EXT_ADDR &&
+                     receivedMacHdr.GetDstAddrMode() == EXT_ADDR)
             {
-                NS_LOG_DEBUG("Packet from " << params.m_srcExtAddr);
-                NS_LOG_DEBUG("Packet to " << params.m_dstExtAddr);
+                NS_LOG_DEBUG("Packet from [" << params.m_srcExtAddr << "] to ["
+                                             << params.m_dstExtAddr << "]");
+            }
+            else if (receivedMacHdr.GetSrcAddrMode() == SHORT_ADDR &&
+                     receivedMacHdr.GetDstAddrMode() == EXT_ADDR)
+            {
+                NS_LOG_DEBUG("Packet from [" << params.m_srcAddr << "] to [" << params.m_dstExtAddr
+                                             << "]");
+            }
+            else if (receivedMacHdr.GetSrcAddrMode() == EXT_ADDR &&
+                     receivedMacHdr.GetDstAddrMode() == SHORT_ADDR)
+            {
+                NS_LOG_DEBUG("Packet from [" << params.m_srcExtAddr << "] to [" << params.m_dstAddr
+                                             << "]");
             }
 
             // TODO: Fix here, this should trigger different Indication Callbacks
